function [mu,q,X,muX] = FindMean3Dcurve(X1)

close all;

%input: set of curves X1 as a 3xnxm array where n is the number of points
%sampled on the curve and m is the sample size
%output: mean SRVF mu, SRVFs of original curves q and mean curve muX

% Resample the data to 100 points according to arc-length
for i = 1:size(X1,3)
    X(:,:,i)=ReSampleCurve(X1(:,:,i),100);
    [q(:,:,i)] = curve_to_q(X(:,:,i));
end

% Apply iterative algorithm
[mu,~,dE] = FindKarcherMean(q,X);

% Plot energy gradient
figure(3),clf;
plot(dE(2:end),'LineWidth',2)
set(gca,'FontSize',20)

muX = q_to_curve(mu);